## odil 0.12.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project("odil")

set(odil_VERSION 0.12.0)
string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" _ "${odil_VERSION}")
set(odil_MAJOR_VERSION "${CMAKE_MATCH_1}")
set(odil_MINOR_VERSION "${CMAKE_MATCH_2}")
set(odil_PATCH_VERSION "${CMAKE_MATCH_3}")

option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
option(BUILD_EXAMPLES "Build the examples directory." ON)
option(BUILD_PYTHON_WRAPPERS "Build the Python Wrappers." ON)
option(BUILD_JAVASCRIPT_WRAPPERS "Build the Javascript Wrappers." OFF)

option(WITH_DCMTK "Build the DCMTK converter" ON)
option(
    USE_BUILTIN_DCMTK_GETSCU
    "Compile a locally packaged version of getscu for old DCMTK versions" ON)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}" ${CMAKE_MODULE_PATH})
set(CMAKE_INSTALL_MESSAGE LAZY)

include(CTest)
include(cmake/functions.cmake)

# Add the C++0x or C++11 flag
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-std=c++11 COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG(-std=c++0x COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if(WIN32)
    # We have to set _WIN32_WINNT for Asio
    if(${CMAKE_SYSTEM_VERSION} EQUAL 10) # Windows 10
        add_definitions(-D _WIN32_WINNT=0x0A00)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
        add_definitions(-D _WIN32_WINNT=0x0603)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
        add_definitions(-D _WIN32_WINNT=0x0602)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
        add_definitions(-D _WIN32_WINNT=0x0601)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
        add_definitions(-D _WIN32_WINNT=0x0600)
    else() # Windows XP (5.1)
        add_definitions(-D _WIN32_WINNT=0x0501)
    endif()
    
    # Starting with Visual Studio 2015 / VC 14 / MSVC 19.00, snprintf is present
    if(${MSVC_VERSION} GREATER_EQUAL "1900")
        add_definitions(-D HAVE_SNPRINTF)
    endif()
endif()

add_subdirectory("src")

if(BUILD_EXAMPLES)
    add_subdirectory("examples")
endif()

if(BUILD_TESTING)
    add_subdirectory("tests")
endif()

if(BUILD_PYTHON_WRAPPERS)
    add_subdirectory("wrappers/python")
    add_subdirectory("applications")
endif()

if(BUILD_JAVASCRIPT_WRAPPERS)
    add_subdirectory("wrappers/js")
endif()

file(GLOB_RECURSE ci_resources .ci/*)
add_custom_target(
    CIIntegration ${CMAKE_COMMAND} -E echo "CI Integration"
    SOURCES appveyor.yml .travis.yml ${ci_resources})
set_target_properties(CIIntegration PROPERTIES FOLDER "Utils")

file(GLOB_RECURSE documentation documentation/*)
add_custom_target(
    Documentation ${CMAKE_COMMAND} -E echo "Documentation"
    SOURCES LICENSE.txt README.md ${documentation})
set_target_properties(Documentation PROPERTIES FOLDER "Utils")

file(GLOB_RECURSE registry_templates registry*.tmpl)
add_custom_target(
    Registry ${CMAKE_COMMAND} -E echo "Registry"
    SOURCES generate_registry ${registry_templates})
set_target_properties(Registry PROPERTIES FOLDER "Utils")

=== tests/CMakeLists.txt ===
find_package(Boost COMPONENTS unit_test_framework REQUIRED)
find_package(DCMTK REQUIRED)
find_package(JsonCpp REQUIRED)

add_subdirectory(tools)

file(GLOB headers *.h)
file(GLOB_RECURSE tests code/*.cpp)
if(NOT WITH_DCMTK)
    list(
        REMOVE_ITEM tests
        ${CMAKE_CURRENT_SOURCE_DIR}/code/conversion.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/code/DcmtkException.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/code/ElementAccessor.cpp)
    set(
        extra_files
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/conversion.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/ElementAccessor.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/ElementTraits.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/Exception.cpp)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
    ${JsonCpp_INCLUDE_DIRS})

add_definitions(
    ${DCMTK_DEFINITIONS}
    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
)
if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})


foreach(test_file ${tests})
    get_filename_component(unit ${test_file} NAME_WE)
    get_filename_component(module ${test_file} PATH)
    get_filename_component(module ${module} NAME)
    if(NOT "${module}" STREQUAL "code")
        set(test "${module}_${unit}")
    else()
        set(test "${unit}")
    endif()

    add_executable(test_${test} ${test_file} ${headers} ${extra_files})
    
    target_link_libraries(
        test_${test} libodil ${Boost_LIBRARIES} ${DCMTK_LIBRARIES})
    if(WIN32)
        target_link_libraries(test_${test} Ws2_32)
    endif()
    
    set_target_properties(test_${test} PROPERTIES OUTPUT_NAME ${test} FOLDER "Tests")

    file(READ ${test_file} content)

    set(pattern "BOOST_(AUTO|FIXTURE)_TEST_CASE\\(([^),]+)")

    string(REGEX MATCHALL ${pattern} cases ${content})

    foreach(case ${cases})
        string(REGEX REPLACE ${pattern} "\\2" case ${case})
        if(NOT ${case} MATCHES "##")
            add_test("${test}_${case}" "${test}" "--run_test=${case}")
        endif()
    endforeach()

    set(pattern "ElementTest\\([\n ]+([A-Z]+)")

    string(REGEX MATCHALL ${pattern} matches ${content})

    foreach(match ${matches})
        string(REGEX REPLACE ${pattern} "\\1" vr ${match})

        set(case "${vr}FromOdil")
        add_test("${test}_${case}" "${test}" "--run_test=${case}")

        set(case "${vr}ToOdil")
        add_test("${test}_${case}" "${test}" "--run_test=${case}")
    endforeach()

endforeach()

file(GLOB_RECURSE python_tests *.py)

add_custom_target(
    PythonTests ${CMAKE_COMMAND} -E echo "Python tests" SOURCES ${python_tests})

=== debian/changelog ===
odil (0.12.0-2build1) groovy; urgency=medium

  * No-change rebuild against libicu67

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 16:14:23 +0000

odil (0.12.0-2) unstable; urgency=medium

  * Remove support for mips64el. Closes: #956749

 -- Julien Lamy <lamy@unistra.fr>  Wed, 15 Apr 2020 16:48:12 +0000

odil (0.12.0-1) unstable; urgency=medium

  [ Julien Lamy ]
  * New upstream release.
  * Remove parallel build

  [ Andreas Tille ]
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Julien Lamy <lamy@unistra.fr>  Wed, 08 Apr 2020 11:08:21 +0200

=== debian/control ===
Source: odil
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Lamy <lamy@unistra.fr>
Section: science
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 12),
               d-shlibs (>= 0.81),
               dh-python,
               cmake,
               g++ (>= 4:7),
               pkg-config,
               libjsoncpp-dev,
               libdcmtk-dev | libdcmtk2-dev,
               libicu-dev,
               zlib1g-dev,
               uuid-dev,
               libboost-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-log-dev,
               libboost-python-dev,
               pybind11-dev,
               python3-pybind11,
               libboost-test-dev,
               chrpath,
               dcmtk,
               python3-all,
               python3-all-dev
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/odil
Vcs-Git: https://salsa.debian.org/med-team/odil.git
Homepage: https://github.com/lamyj/odil
Rules-Requires-Root: no

Package: libodil0
Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x alpha ia64 powerpc ppc64 riscv64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libdcmtkpp0
Provides: libdcmtkpp0
Replaces: libdcmtkpp0
Description: C++11 library for the DICOM standard
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 Odil also provides conversion to and from DCMTK data structures.
 .
 This package contains the shared library.

Package: libodil-dev
Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x
Multi-Arch: same
Section: libdevel
Depends: libodil0 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Conflicts: libodil0-dev,
           libdcmtkpp-dev
Provides: libodil0-dev,
          libdcmtkpp-dev
Replaces: libodil0-dev,
          libdcmtkpp-dev
Description: C++11 library for the DICOM standard (development files)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the development files.

Package: libodil-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Conflicts: libodil0-doc,
           libdcmtkpp0-doc
Provides: libodil0-doc,
          libdcmtkpp0-doc
Replaces: libodil0-doc,
          libdcmtkpp0-doc
Description: C++11 library for the DICOM standard (documentation)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the documentation files.

Package: python3-odil
Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x
Multi-Arch: foreign
Section: python
Depends: libodil0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Description: C++11 library for the DICOM standard (Python 3 wrappers)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the Python 3 wrappers.

Package: odil
Architecture: all
Depends: python3-odil,
         ${python3:Depends},
         ${misc:Depends}
Description: C++11 library for the DICOM standard (application)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the command-line application.

## odil 0.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,11 @@
 cmake_minimum_required(VERSION 3.5)
+if(${CMAKE_VERSION} VERSION_LESS 3.12)
+    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
+else()
+    cmake_policy(SET CMP0074 NEW)
+endif()
 
-project("odil")
-
-set(odil_VERSION 0.12.0)
-string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" _ "${odil_VERSION}")
-set(odil_MAJOR_VERSION "${CMAKE_MATCH_1}")
-set(odil_MINOR_VERSION "${CMAKE_MATCH_2}")
-set(odil_PATCH_VERSION "${CMAKE_MATCH_3}")
+project("Odil" VERSION 0.12.1)
 
 option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
 option(BUILD_EXAMPLES "Build the examples directory." ON)
@@ -16,23 +15,16 @@
 option(WITH_DCMTK "Build the DCMTK converter" ON)
 option(
     USE_BUILTIN_DCMTK_GETSCU
-    "Compile a locally packaged version of getscu for old DCMTK versions" ON)
+    "Compile a locally packaged version of getscu for old DCMTK versions" OFF)
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}" ${CMAKE_MODULE_PATH})
 set(CMAKE_INSTALL_MESSAGE LAZY)
 
 include(CTest)
-include(cmake/functions.cmake)
+include(CMakePackageConfigHelpers)
 
-# Add the C++0x or C++11 flag
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG(-std=c++11 COMPILER_SUPPORTS_CXX11)
-CHECK_CXX_COMPILER_FLAG(-std=c++0x COMPILER_SUPPORTS_CXX0X)
-if(COMPILER_SUPPORTS_CXX11)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
-elseif(COMPILER_SUPPORTS_CXX0X)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
-endif()
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
@@ -94,3 +86,32 @@
     Registry ${CMAKE_COMMAND} -E echo "Registry"
     SOURCES generate_registry ${registry_templates})
 set_target_properties(Registry PROPERTIES FOLDER "Utils")
+
+# Export the build tree (don't install the generated file)
+export(
+    TARGETS libodil NAMESPACE Odil:: 
+    FILE "${PROJECT_BINARY_DIR}/OdilTargets.cmake")
+
+# Export the install tree
+write_basic_package_version_file(
+    "OdilConfigVersion.cmake" COMPATIBILITY SameMajorVersion)
+set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_PREFIX}/lib/CMake/Odil")
+install(EXPORT OdilTargets NAMESPACE Odil:: DESTINATION "${INSTALL_CMAKE_DIR}")
+configure_file(OdilConfig.cmake.in OdilConfig.cmake @ONLY)
+install(
+    FILES 
+        FindJsonCpp.cmake
+        ${CMAKE_CURRENT_BINARY_DIR}/OdilConfig.cmake
+        ${CMAKE_CURRENT_BINARY_DIR}/OdilConfigVersion.cmake
+    DESTINATION "${INSTALL_CMAKE_DIR}")
+
+# "uninstall" target
+if(NOT TARGET uninstall)
+  configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+    IMMEDIATE @ONLY)
+
+  add_custom_target(uninstall
+    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+endif()

=== src/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS date_time exception filesystem log system)
find_package(ICU REQUIRED COMPONENTS uc)
find_package(JsonCpp REQUIRED)
if(WITH_DCMTK)
    find_package(DCMTK REQUIRED)
endif()

file(GLOB_RECURSE Header_Files "*.h")
file(GLOB_RECURSE Source_Files "*.cpp")
file(GLOB_RECURSE templates "*.txx")
list(SORT Header_Files)
list(SORT Source_Files)
list(SORT templates)

if(NOT WITH_DCMTK)
    set(pattern "${CMAKE_CURRENT_SOURCE_DIR}/odil/dcmtk/[^;]+[;$]")
    string(REGEX REPLACE ${pattern} "" Header_Files "${Header_Files}")
    string(REGEX REPLACE ${pattern} "" Source_Files "${Source_Files}")
    string(REGEX REPLACE ${pattern} "" templates "${templates}")
endif()

add_library(libodil ${Source_Files} ${Header_Files} ${templates})

target_compile_definitions(
    libodil 
    PUBLIC
        BOOST_ASIO_SEPARATE_COMPILATION ${DCMTK_DEFINITIONS}
        ODIL_VERSION_MAJOR=${Odil_VERSION_MAJOR}
        $<$<BOOL:BUILD_SHARED_LIBS>:BOOST_ALL_DYN_LINK>
        $<$<PLATFORM_ID:Windows>:BOOST_UUID_FORCE_AUTO_LINK>
    PRIVATE 
        $<$<PLATFORM_ID:Windows>:BUILDING_ODIL>)

target_include_directories(
    libodil 
    PUBLIC 
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/> $<INSTALL_INTERFACE:>
        "$<$<BOOL:${WITH_DCMTK}>:${DCMTK_INCLUDE_DIRS}>")

target_link_libraries(
    libodil 
    PUBLIC
        Boost::date_time Boost::exception Boost::filesystem Boost::log 
        "$<$<BOOL:${WITH_DCMTK}>:${DCMTK_LIBRARIES}>"
        ICU::uc JsonCpp::JsonCpp
        $<$<PLATFORM_ID:Windows>:netapi32>
        # WARNING Need to link with bcrypt explicitely, 
        # cf. https://github.com/boostorg/uuid/issues/68#issuecomment-430173245
        # Not sure why iphlpapi is not linked.
        "$<$<BOOL:${VCPKG_TOOLCHAIN}>:bcrypt;iphlpapi>")

if(APPLE)
    # WARNING: Boost::log may add -licudata  -licui18n  -licuu, which cause 
    # problems with macOS/brew
    get_filename_component(ICU_FOUND_DIRECTORY "${ICU_UC_LIBRARY}" DIRECTORY)
    target_link_libraries(libodil PUBLIC "-L${ICU_FOUND_DIRECTORY}")
endif()

set_target_properties(
    libodil PROPERTIES 
    PUBLIC_HEADER "${Header_Files};${templates}"
    OUTPUT_NAME odil 
    VERSION ${Odil_VERSION} 
    SOVERSION ${Odil_VERSION_MAJOR}
    $<$<PLATFORM_ID:Darwin>:INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib>)

install(
    TARGETS libodil
    EXPORT OdilTargets
    ARCHIVE DESTINATION bin LIBRARY DESTINATION lib RUNTIME DESTINATION bin
    PUBLIC_HEADER DESTINATION include/odil
    INCLUDES DESTINATION include)

=== wrappers/python/CMakeLists.txt ===
find_package(JsonCpp REQUIRED)
find_package(pybind11 REQUIRED)

file(GLOB_RECURSE Header_Files "*.h")
file(GLOB_RECURSE Source_Files "*.cpp")
set(Python_Files "__init__.py")

list(SORT Header_Files)
list(SORT Source_Files)
list(SORT Python_Files)

pybind11_add_module(pyodil SHARED ${Source_Files} ${Header_Files})

target_compile_definitions(
    pyodil PRIVATE $<$<BOOL:BUILD_SHARED_LIBS>:BOOST_ALL_DYN_LINK>)

target_include_directories(
    pyodil 
    PRIVATE $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src> ${PYTHON_INCLUDE_DIRS})

target_link_libraries(pyodil PRIVATE JsonCpp::JsonCpp libodil)

set_target_properties(
    pyodil PROPERTIES 
    OUTPUT_NAME _odil 
    FOLDER "Wrappers"
    $<$<PLATFORM_ID:Darwin>:SUFFIX .so>)

execute_process(
    COMMAND ${PYTHON_EXECUTABLE}
      -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix='').replace('\\\\', '/'))"
    OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
    OUTPUT_STRIP_TRAILING_WHITESPACE)

install(TARGETS pyodil DESTINATION "${PYTHON_SITE_PACKAGES}/odil")
install(FILES ${Python_Files} DESTINATION "${PYTHON_SITE_PACKAGES}/odil")

=== debian/changelog ===
odil (0.12.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Lamy <lamy@unistra.fr>  Wed, 13 Jan 2021 17:37:20 +0100

odil (0.12.0-3) unstable; urgency=medium

  * Team Upload.
  * Fix Boost-1.74 FTBFS with upstream commit (Closes: #975587)

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 05 Dec 2020 16:44:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: odil
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Julien Lamy <lamy@unistra.fr>
 Section: science
 Testsuite: autopkgtest-pkg-python

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# needed for the tests
export DCMDICTPATH=$(shell ls /usr/share/libdcmtk*/dicom.dic | head -n 1)

# Find all Python versions
PYTHON3=$(shell py3versions -vd)
ALLPY=$(shell py3versions -vs)

%:
	# NOTE: although Odil correctly builds in parallel, it requires a huge
	# amount of RAM to do so. Disable parallel building to avoid build
	# failures.
	dh $@ --builddirectory=build --with python3 --no-parallel

# Base build: no wrappers
override_dh_auto_configure-arch:
	dh_auto_configure -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=OFF -DBUILD_JAVASCRIPT_WRAPPERS=OFF

override_dh_auto_build-nopy:
	dh_auto_build
	mv build build-nopy

# Reconfigure base build for specific Python version and build wrappers
# WARNING: builds for Python versions MUST be sequential since they use the
# same build directory
override_dh_auto_build-py: override_dh_auto_build-nopy
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Building for Python $${Python} ==="; \
	  cp -a build-nopy build; \
	  dh_auto_configure -- \
	    -DBUILD_EXAMPLES=OFF \
	    -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	    -DPYTHON_EXECUTABLE=/usr/bin/python$${Python}; \
	  dh_auto_build; \
	  mv build build-py$${Python}; \
	done

override_dh_auto_build-arch: override_dh_auto_build-nopy override_dh_auto_build-py

override_dh_auto_build-indep:
	dh_auto_configure --builddirectory=build-indep -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	  -DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON3)
	mkdir -p documentation/_build
	cd documentation && doxygen
	find documentation/_build -name "*.md5" -delete

# WARNING: tests for Python versions MUST be sequential since they use the
# same build directory
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Testing for Python $${Python} ==="; \
	  ln -s build-py$${Python} build; \
	  ln -sr ./build/wrappers/python ./build/odil; \
	  ln -sr ./wrappers/python/*.py ./build/odil; \
	  cd build && \
	    $(MAKE) install DESTDIR=../install && \
	    WORKSPACE=$(CURDIR) ../.ci/deb/post_build || true;\
	  cd ..; \
	  rm ./build/odil/*py; \
	  rm ./build/odil; \
	  rm build; \
	  rm -rf install; \
	done
endif

override_dh_auto_install-arch-nopy:
	ln -s build-nopy build
	$(MAKE) -C build/src install DESTDIR=$(CURDIR)/debian/tmp
	rm build

# WARNING: installs for Python versions MUST be sequential since they use the
# same build directory
override_dh_auto_install-arch-py: override_dh_auto_install-arch-nopy
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Installing for Python $${Python} ==="; \
	  ln -s build-py$${Python} build; \
	  $(MAKE) -C build/wrappers/python install DESTDIR=$(CURDIR)/debian/tmp; \
	  rm build; \
	done

override_dh_auto_install-arch: override_dh_auto_install-arch-nopy override_dh_auto_install-arch-py

override_dh_auto_install-indep:
	ln -s build-indep build
	$(MAKE) -C build/applications install DESTDIR=$(CURDIR)/debian/tmp
	rm build

override_dh_install-arch:
	dh_install
	d-shlibmove \
		--devunversioned \
		--commit --multiarch --exclude-a --exclude-la \
		--movedev debian/tmp/usr/include/* usr/include \
		--override s/libboost_log.*-dev/libboost-log-dev/ \
		debian/tmp/usr/lib/*.so

override_dh_clean:
	dh_clean
	find tests -name "*pyc" -delete
	rm -rf build-nopy $(ALLPY:%=build-py%) build-indep documentation/_build
	rm -f build

# These steps are not needed for arch-independent packages
override_dh_auto_configure-indep:
override_dh_auto_test-indep:

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/odil-$1\.tar\.gz/,\
pgpsigurlmangle=s/archive/releases\/download/;\
s/([^\/]+)\.tar\.gz/$1\/$1\.tar\.gz/;\
s/$/.asc/ \
  https://github.com/lamyj/odil/tags .*/v?(\d\S*)\.tar\.gz

## odil 0.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.7)
 if(${CMAKE_VERSION} VERSION_LESS 3.12)
     cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 else()
     cmake_policy(SET CMP0074 NEW)
 endif()
 
-project("Odil" VERSION 0.12.1)
+project("Odil" VERSION 0.12.2)
 
 option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
 option(BUILD_EXAMPLES "Build the examples directory." ON)
@@ -23,7 +23,9 @@
 include(CTest)
 include(CMakePackageConfigHelpers)
 
-set(CMAKE_CXX_STANDARD 11)
+if(NOT CMAKE_CXX_STANDARD)
+    set(CMAKE_CXX_STANDARD 11)
+endif()
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
         "$<$<BOOL:${WITH_DCMTK}>:${DCMTK_LIBRARIES}>"
         ICU::uc JsonCpp::JsonCpp
         $<$<PLATFORM_ID:Windows>:netapi32>
-        # WARNING Need to link with bcrypt explicitely, 
+        # WARNING Need to link with bcrypt explicitly, 
         # cf. https://github.com/boostorg/uuid/issues/68#issuecomment-430173245
         # Not sure why iphlpapi is not linked.
         "$<$<BOOL:${VCPKG_TOOLCHAIN}>:bcrypt;iphlpapi>")
@@ -53,7 +53,9 @@
     # WARNING: Boost::log may add -licudata  -licui18n  -licuu, which cause 
     # problems with macOS/brew
     get_filename_component(ICU_FOUND_DIRECTORY "${ICU_UC_LIBRARY}" DIRECTORY)
-    target_link_libraries(libodil PUBLIC "-L${ICU_FOUND_DIRECTORY}")
+    if(NOT "${ICU_FOUND_DIRECTORY}" STREQUAL "")
+        target_link_libraries(libodil PUBLIC "-L${ICU_FOUND_DIRECTORY}")
+    endif()
 endif()
 
 set_target_properties(
@@ -70,3 +72,11 @@
     ARCHIVE DESTINATION bin LIBRARY DESTINATION lib RUNTIME DESTINATION bin
     PUBLIC_HEADER DESTINATION include/odil
     INCLUDES DESTINATION include)
+
+foreach(include_file ${Header_Files} ${templates})
+    file(
+        RELATIVE_PATH 
+        include_path ${CMAKE_CURRENT_SOURCE_DIR} ${include_file})
+    get_filename_component(include_path ${include_path} PATH)
+    install(FILES ${include_file} DESTINATION "include/${include_path}")
+endforeach()

=== debian/changelog ===
odil (0.12.2-5) unstable; urgency=medium

  * Team upload.
  * Add explicit build-depend on python3-setuptools. Closes: #1080681
  * d/control: use new name for pkg-config → pkgconf
  * Remove trailing whitespace in debian/control (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 10 Sep 2024 14:00:13 +0200

odil (0.12.2-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062757

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:46:17 +0000

odil (0.12.2-4) unstable; urgency=medium

  * Team upload.
  * Add loong64 support
    Closes: #1058992
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 21 Dec 2023 20:12:20 +0100

odil (0.12.2-3) unstable; urgency=medium

  * Fix FTBS with g++-13 (Closes: #1037795)

 -- Julien Lamy <lamy@unistra.fr>  Tue, 27 Jun 2023 20:01:17 +0200

odil (0.12.2-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against dcmtk 3.6.7
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 12 May 2022 10:30:48 +0200

odil (0.12.2-1) unstable; urgency=medium

  * New upstream version 0.12.2

 -- Julien Lamy <lamy@unistra.fr>  Tue, 19 Apr 2022 17:36:06 +0200

odil (0.12.1-5) unstable; urgency=medium

  * Fix compilation against DCMTK (Closes: #1005261)
  * Bump copyright year
  * Fix fetching signature in d/watch

 -- Julien Lamy <lamy@unistra.fr>  Thu, 10 Feb 2022 10:50:44 +0100

odil (0.12.1-4) unstable; urgency=medium

  * Backport code from upstream to adapt to new pybind API
    (Closes: #1002134)

 -- Julien Lamy <lamy@unistra.fr>  Wed, 22 Dec 2021 09:11:01 +0100

odil (0.12.1-3) unstable; urgency=medium

  * Remove network-related unit tests (Closes: #1001614)

 -- Julien Lamy <lamy@unistra.fr>  Thu, 16 Dec 2021 11:54:07 +0100

odil (0.12.1-2) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Drop needless override for d-shlibs
    Closes: #999841
  * Enable dh_missing --fail-missing
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * watch file standard 4 (routine-update)

  [ Julien Lamy ]
  * Fix compilation with latest DCMTK
  * Fix lintian issue with build dependencies

 -- Andreas Tille <tille@debian.org>  Thu, 18 Nov 2021 09:11:09 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,13 @@
 Section: science
 Testsuite: autopkgtest-pkg-python
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               d-shlibs (>= 0.81),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
+               d-shlibs (>= 0.106),
                dh-python,
                cmake,
-               g++ (>= 4:7),
-               pkg-config,
+               pkgconf,
                libjsoncpp-dev,
-               libdcmtk-dev | libdcmtk2-dev,
+               libdcmtk-dev,
                libicu-dev,
                zlib1g-dev,
                uuid-dev,
@@ -26,24 +25,25 @@
                chrpath,
                dcmtk,
                python3-all,
+               python3-setuptools,
                python3-all-dev
 Build-Depends-Indep: doxygen,
                      graphviz
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/odil
 Vcs-Git: https://salsa.debian.org/med-team/odil.git
 Homepage: https://github.com/lamyj/odil
 Rules-Requires-Root: no
 
-Package: libodil0
-Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x alpha ia64 powerpc ppc64 riscv64 x32
+Package: libodil0t64
+Architecture: amd64 arm64 armel armhf i386 loong64 mipsel ppc64el s390x alpha ia64 powerpc ppc64 riscv64 x32
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Conflicts: libdcmtkpp0
-Provides: libdcmtkpp0
-Replaces: libdcmtkpp0
+Conflicts: libodil0 (<< ${source:Version}), libdcmtkpp0
+Provides: ${t64:Provides}, libdcmtkpp0
+Replaces: libodil0, libdcmtkpp0
 Description: C++11 library for the DICOM standard
  Odil leverages C++ constructs to provide a user-friendly API of the
  different parts of the DICOM standard. Included in Odil are exception-based
@@ -56,18 +56,16 @@
  This package contains the shared library.
 
 Package: libodil-dev
-Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x
+Architecture: amd64 arm64 armel armhf i386 loong64 mipsel ppc64el s390x
 Multi-Arch: same
 Section: libdevel
-Depends: libodil0 (= ${binary:Version}),
+Depends: libodil0t64 (= ${binary:Version}),
          ${devlibs:Depends},
          ${misc:Depends}
-Conflicts: libodil0-dev,
-           libdcmtkpp-dev
+Conflicts: libdcmtkpp-dev
 Provides: libodil0-dev,
           libdcmtkpp-dev
-Replaces: libodil0-dev,
-          libdcmtkpp-dev
+Replaces: libdcmtkpp-dev
 Description: C++11 library for the DICOM standard (development files)
  Odil leverages C++ constructs to provide a user-friendly API of the
  different parts of the DICOM standard. Included in Odil are exception-based
@@ -83,12 +81,10 @@
 Section: doc
 Depends: libjs-jquery,
          ${misc:Depends}
-Conflicts: libodil0-doc,
-           libdcmtkpp0-doc
+Conflicts: libdcmtkpp0-doc
 Provides: libodil0-doc,
           libdcmtkpp0-doc
-Replaces: libodil0-doc,
-          libdcmtkpp0-doc
+Replaces: libdcmtkpp0-doc
 Description: C++11 library for the DICOM standard (documentation)
  Odil leverages C++ constructs to provide a user-friendly API of the
  different parts of the DICOM standard. Included in Odil are exception-based
@@ -99,10 +95,10 @@
  This package contains the documentation files.
 
 Package: python3-odil
-Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x
+Architecture: amd64 arm64 armel armhf i386 loong64 mipsel ppc64el s390x
 Multi-Arch: foreign
 Section: python
-Depends: libodil0 (= ${binary:Version}),
+Depends: libodil0t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${python3:Depends},
          ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 # Base build: no wrappers
 override_dh_auto_configure-arch:
 	dh_auto_configure -- \
+	  -DCMAKE_CXX_STANDARD=17 \
 	  -DBUILD_EXAMPLES=OFF \
 	  -DBUILD_PYTHON_WRAPPERS=OFF -DBUILD_JAVASCRIPT_WRAPPERS=OFF
 
@@ -34,6 +35,7 @@
 	  echo "=== Building for Python $${Python} ==="; \
 	  cp -a build-nopy build; \
 	  dh_auto_configure -- \
+	    -DCMAKE_CXX_STANDARD=17 \
 	    -DBUILD_EXAMPLES=OFF \
 	    -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
 	    -DPYTHON_EXECUTABLE=/usr/bin/python$${Python}; \
@@ -46,6 +48,7 @@
 override_dh_auto_build-indep:
 	dh_auto_configure --builddirectory=build-indep -- \
 	  -DBUILD_EXAMPLES=OFF \
+	  -DCMAKE_CXX_STANDARD=17 \
 	  -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
 	  -DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON3)
 	mkdir -p documentation/_build
@@ -99,11 +102,12 @@
 override_dh_install-arch:
 	dh_install
 	d-shlibmove \
+		--t64 \
 		--devunversioned \
 		--commit --multiarch --exclude-a --exclude-la \
 		--movedev debian/tmp/usr/include/* usr/include \
-		--override s/libboost_log.*-dev/libboost-log-dev/ \
 		debian/tmp/usr/lib/*.so
+	find debian -name "lib*.la" -delete
 
 override_dh_clean:
 	dh_clean

## odil 0.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     cmake_policy(SET CMP0074 NEW)
 endif()
 
-project("Odil" VERSION 0.12.2)
+project("Odil" VERSION 0.13.0)
 
 option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
 option(BUILD_EXAMPLES "Build the examples directory." ON)
@@ -71,12 +71,6 @@
     add_subdirectory("wrappers/js")
 endif()
 
-file(GLOB_RECURSE ci_resources .ci/*)
-add_custom_target(
-    CIIntegration ${CMAKE_COMMAND} -E echo "CI Integration"
-    SOURCES appveyor.yml .travis.yml ${ci_resources})
-set_target_properties(CIIntegration PROPERTIES FOLDER "Utils")
-
 file(GLOB_RECURSE documentation documentation/*)
 add_custom_target(
     Documentation ${CMAKE_COMMAND} -E echo "Documentation"

=== applications/CMakeLists.txt ===
find_package(Python COMPONENTS Interpreter Development REQUIRED)

file(GLOB_RECURSE module_files *.py)
set(python_files ${module_files} odil)
add_custom_target(
    PythonFiles ${CMAKE_COMMAND} -E echo "Python files" SOURCES ${python_files})
set_target_properties(PythonFiles PROPERTIES FOLDER "Examples")

if(BUILD_PYTHON_WRAPPERS)
    execute_process(
        COMMAND ${Python_EXECUTABLE}
            -c "import os; import sysconfig; \
                scheme = {'posix': 'posix_prefix', 'nt': 'nt'}[os.name]; \
                path = sysconfig.get_path('purelib', scheme, {'base': '.'}); \
                print(path.replace(os.path.sep, '/'))"
        OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
        OUTPUT_STRIP_TRAILING_WHITESPACE)

    install(DIRECTORY DESTINATION "${PYTHON_SITE_PACKAGES}")
    install(FILES ${module_files} DESTINATION "${PYTHON_SITE_PACKAGES}/odil/cli")
    configure_file("odil" "${CMAKE_CURRENT_BINARY_DIR}/odil")
    install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/odil" DESTINATION bin)
endif()

=== documentation/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Odil
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== examples/CMakeLists.txt ===
option(INSTALL_EXAMPLES "Install the examples" OFF)

add_subdirectory("cpp")
add_subdirectory("python")
add_subdirectory("js")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
-find_package(Boost COMPONENTS unit_test_framework REQUIRED)
+find_package(
+    Boost COMPONENTS exception filesystem log unit_test_framework REQUIRED)
 find_package(DCMTK REQUIRED)
 find_package(JsonCpp REQUIRED)
 
@@ -20,21 +21,6 @@
         ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/Exception.cpp)
 endif()
 
-include_directories(
-    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
-    ${JsonCpp_INCLUDE_DIRS})
-
-add_definitions(
-    ${DCMTK_DEFINITIONS}
-    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
-)
-if(BUILD_SHARED_LIBS)
-    add_definitions(-D BOOST_ALL_DYN_LINK)
-endif()
-
-link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})
-
-
 foreach(test_file ${tests})
     get_filename_component(unit ${test_file} NAME_WE)
     get_filename_component(module ${test_file} PATH)
@@ -47,13 +33,25 @@
 
     add_executable(test_${test} ${test_file} ${headers} ${extra_files})
     
+    target_compile_definitions(
+        test_${test} 
+        PRIVATE
+            BOOST_ASIO_SEPARATE_COMPILATION ${DCMTK_DEFINITIONS}
+            ODIL_VERSION_MAJOR=${Odil_VERSION_MAJOR}
+            $<$<BOOL:BUILD_SHARED_LIBS>:BOOST_ALL_DYN_LINK>)
+    
+    target_include_directories(
+        test_${test} PRIVATE ${CMAKE_SOURCE_DIR}/src ${DCMTK_INCLUDE_DIRS})
+    
     target_link_libraries(
-        test_${test} libodil ${Boost_LIBRARIES} ${DCMTK_LIBRARIES})
-    if(WIN32)
-        target_link_libraries(test_${test} Ws2_32)
-    endif()
+        test_${test} 
+        PRIVATE 
+            Boost::unit_test_framework ${DCMTK_LIBRARIES} JsonCpp::JsonCpp 
+            libodil
+            $<$<PLATFORM_ID:Windows>:Ws2_32>)
     
-    set_target_properties(test_${test} PROPERTIES OUTPUT_NAME ${test} FOLDER "Tests")
+    set_target_properties(
+        test_${test} PROPERTIES OUTPUT_NAME ${test} FOLDER "Tests")
 
     file(READ ${test_file} content)

=== examples/cpp/CMakeLists.txt ===
find_package(Boost REQUIRED)
find_package(DCMTK REQUIRED)
find_package(JsonCpp REQUIRED)

include_directories(
    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
    ${JsonCpp_INCLUDE_DIRS})

add_definitions(
    ${DCMTK_DEFINITIONS}
    -D ODIL_MAJOR_VERSION=${Odil_VERSION_MAJOR}
)
if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})

file(GLOB_RECURSE examples *.cpp)

foreach(example_file ${examples})
    get_filename_component(example ${example_file} NAME_WE)
    add_executable(${example} ${example_file})
    target_link_libraries(${example} libodil)
    if(INSTALL_EXAMPLES)
        install(TARGETS ${example} RUNTIME DESTINATION bin)
    endif()
    set_target_properties(${example} PROPERTIES FOLDER "Examples")
endforeach()

=== examples/js/CMakeLists.txt ===
file(GLOB_RECURSE examples *.js *.html)
add_custom_target(
    JavascriptExamples
    ${CMAKE_COMMAND} -E echo "Javascript examples"
    SOURCES ${examples})
set_target_properties(JavascriptExamples PROPERTIES FOLDER "Examples")

=== examples/python/CMakeLists.txt ===
file(GLOB_RECURSE examples *.py)
add_custom_target(
    PythonExamples
    ${CMAKE_COMMAND} -E echo "Python examples"
    SOURCES ${examples})
set_target_properties(PythonExamples PROPERTIES FOLDER "Examples")

=== tests/tools/CMakeLists.txt ===
find_package(DCMTK REQUIRED)

add_definitions(${DCMTK_DEFINITIONS})
include_directories(${DCMTK_INCLUDE_DIRS})
link_directories(${DCMTK_LIBRARY_DIRS})

file(GLOB headers *.h)
file(GLOB files "*.cc")

if(USE_BUILTIN_DCMTK_GETSCU)
    add_executable(dcmtk_getscu ${files} ${headers})
    target_link_libraries(dcmtk_getscu ${DCMTK_LIBRARIES})
    set_target_properties(dcmtk_getscu PROPERTIES OUTPUT_NAME getscu)
endif()

=== wrappers/js/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS system)

if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common")
    file(
        DOWNLOAD http://download.icu-project.org/files/icu4c/58.2/icu4c-58_2-src.zip
        ${CMAKE_CURRENT_BINARY_DIR}/icu4c-58_2-src.zip SHOW_PROGRESS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E tar x icu4c-58_2-src.zip
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endif()

if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/jsoncpp.cpp")
    file(
        DOWNLOAD https://github.com/open-source-parsers/jsoncpp/archive/1.8.0.zip 
        ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0.zip SHOW_PROGRESS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E tar x jsoncpp-1.8.0.zip
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    execute_process(
        COMMAND python amalgamate.py 
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0)
endif()

if (NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/boost")
    execute_process( COMMAND ln -s ${Boost_INCLUDE_DIRS}/boost ${CMAKE_CURRENT_BINARY_DIR})
endif()

set(icu_files
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/bytestream.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/charstr.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/cmemory.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/putil.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/stringpiece.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucln_cmn.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucmndata.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv2022.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvbocu.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvhz.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvisci.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvlat1.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvmbcs.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvscsu.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_bld.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_cb.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_ct.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_cnv.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_err.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_ext.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_io.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_lmb.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u7.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u8.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u16.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u32.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/udata.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/udatamem.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uhash.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uinvchar.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umapfile.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umath.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umutex.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/unistr.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/unistr_cnv.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uobject.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustr_cnv.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustring.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustrtrns.cpp")

set(json_cpp_files 
    "${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/jsoncpp.cpp")

set(odil_files 
    "${CMAKE_SOURCE_DIR}/src/odil/base64.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/DataSet.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/Element.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/ElementsDictionary.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Exception.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/json_converter.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Reader.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/registry.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Tag.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/uid.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/UIDsDictionary.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/unicode.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Value.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/VR.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/VRFinder.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/HTTPRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/HTTPResponse.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/ItemWithParameters.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/Message.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/multipart_related.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/QIDORSRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/QIDORSResponse.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/Selector.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/URL.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/WADORSRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/WADORSResponse.cpp")

file(GLOB_RECURSE files "*cpp") 

set(CMAKE_C_COMPILER emcc)
set(CMAKE_CXX_COMPILER em++)
set(CMAKE_AR emar)
set(CMAKE_RANLIB emranlib)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --bind -s ALLOW_MEMORY_GROWTH=1 -s DISABLE_EXCEPTION_CATCHING=0")

set(CMAKE_C_CREATE_STATIC_LIBRARY "<CMAKE_AR> rc <TARGET> <LINK_FLAGS> <OBJECTS>")
set(CMAKE_CXX_CREATE_STATIC_LIBRARY "<CMAKE_AR> rc <TARGET> <LINK_FLAGS> <OBJECTS>")

add_definitions(
    -D ODIL_VERSION_MAJOR=${Odil_VERSION_MAJOR}
    -D U_COMMON_IMPLEMENTATION -D U_DISABLE_RENAMING=1
)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/icu/source/common
    ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/
    ${CMAKE_SOURCE_DIR}/src)

add_executable(odil_js ${icu_files} ${json_cpp_files} ${odil_files} ${files})

set_target_properties(odil_js PROPERTIES OUTPUT_NAME odil)
set_target_properties(odil_js PROPERTIES SUFFIX ".js")

=== wrappers/python/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 find_package(JsonCpp REQUIRED)
+find_package(Python COMPONENTS Interpreter Development REQUIRED)
 find_package(pybind11 REQUIRED)
 
 file(GLOB_RECURSE Header_Files "*.h")
@@ -27,8 +28,11 @@
     $<$<PLATFORM_ID:Darwin>:SUFFIX .so>)
 
 execute_process(
-    COMMAND ${PYTHON_EXECUTABLE}
-      -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix='').replace('\\\\', '/'))"
+    COMMAND ${Python_EXECUTABLE}
+        -c "import os; import sysconfig; \
+            scheme = {'posix': 'posix_prefix', 'nt': 'nt'}[os.name]; \
+            path = sysconfig.get_path('purelib', scheme, {'base': '.'}); \
+            print(path.replace(os.path.sep, '/'))"
     OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
     OUTPUT_STRIP_TRAILING_WHITESPACE)

=== debian/changelog ===
odil (0.13.0-1) unstable; urgency=medium

  * New upstream release.
  * Fix building with boost >= 1.87. Closes: #1110619
  * Improve autopkgtests
  * Update standards version to 4.7.2

 -- Julien Lamy <lamy@unistra.fr>  Tue, 19 Aug 2025 10:35:08 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Julien Lamy <lamy@unistra.fr>
 Section: science
-Testsuite: autopkgtest-pkg-python
 Priority: optional
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                d-shlibs (>= 0.106),
@@ -29,7 +28,7 @@
                python3-all-dev
 Build-Depends-Indep: doxygen,
                      graphviz
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/odil
 Vcs-Git: https://salsa.debian.org/med-team/odil.git
 Homepage: https://github.com/lamyj/odil

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# needed for the tests
-export DCMDICTPATH=$(shell ls /usr/share/libdcmtk*/dicom.dic | head -n 1)
 
 # Find all Python versions
 PYTHON3=$(shell py3versions -vd)

=== debian/watch ===
version=4

opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;\
s/([^\/]+)\.tar\.gz/$1\/$1\.tar\.gz/;\
s/$/.asc/ \
  https://github.com/lamyj/odil/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
